<?php
    require_once KCONFIG . '/classes/classKKibs.php';
    require_once KCONFIG . '/classes/KGatewayYaml.php';
    require_once KROOT . '/classes/KLicense.php';
    require_once KROOT . '/classes/KLicenseLimits.php';

    $AjaxFunctions['showServices'] = 'showServices';
    $AjaxFunctions['saveServices'] = 'saveServices';
    $AjaxFunctions['showKIBS'] = 'showKIBS';
    $AjaxFunctions['saveKIBS'] = 'saveKIBS';
    $AjaxFunctions['showMediaServer'] = 'showMediaServer';
    $AjaxFunctions['saveMediaServer'] = 'saveMediaServer';
    $AjaxFunctions['showVoIPOptions'] = 'showVoIPOptions';
    $AjaxFunctions['saveVoIPOptions'] = 'saveVoIPOptions';
    $AjaxFunctions['showVoIPTLS'] = 'showVoIPTLS';
    $AjaxFunctions['saveVoIPTLS'] = 'saveVoIPTLS';
    $AjaxFunctions['saveVoIPClientCertificateVerification'] = 'saveVoIPClientCertificateVerification';
    $AjaxFunctions['deleteVoIPTLSItem'] = 'deleteVoIPTLSItem';
    $AjaxFunctions['showVoIPCodecs'] = 'showVoIPCodecs';
    $AjaxFunctions['saveVoIPCodecs'] = 'saveVoIPCodecs';
    $AjaxFunctions['showAPICompatibility'] = 'showAPICompatibility';
    $AjaxFunctions['saveAPICompatibility'] = 'saveAPICompatibility';
    $AjaxFunctions['showLogsErrorCount'] = 'showLogsErrorCount';
    $AjaxFunctions['saveLogsErrorCount'] = 'saveLogsErrorCount';

    function showServices( $_REQUEST )
    {
        Global $sistema;

        $buff = '';
        $configDir = $sistema->getConfigDir( );

        if( isset( $_SESSION['systemYAML'] ) )
            $sysYAML = unserialize( $_SESSION['systemYAML'] );
        else
        {
            $sysYAML = loadSystemYaml( );
        }

        $buff .= "<div id='services' style='display: block;'>";
        $buff .= "<fieldset>";
        $buff .= "<legend>" . $sistema->retTranslate( 'Services' ) . "</legend>";

        $buff .= "<table id='services' class='zebra'>";
        $buff .= "<thead><tr>";
        $buff .= "<th>" . $sistema->retTranslate( 'Name' ) . "</th>";
        $buff .= "<th>" . $sistema->retTranslate( 'Porta' ) . "</th>";
        $buff .= "<th>" . $sistema->retTranslate( 'Carregamento' ) . "</th>";
        $buff .= "</tr></thead><tbody>";

        $buff .= '<tr><td>Khomp Media Server</td>';
        $buff .= "<td><input type='text' onkeypress='return portMask(this, event);' onkeyup='validatePort(this);' class='inputText' value='" . $sysYAML->getValue( 'MediaServerPort' ) . "' id='MediaServerPort' /></td>";
        $buff .= '<td>' . getSelectorLoadService( 'kmpserver' ) . '</td></tr>';

        $buff .= "<tr><td>Khomp Log Service</td>";
        $logConfigs = loadKLogConfigs( $configDir );
        $buff .= "<td><input type='text' onkeypress='return portMask(this, event);' onkeyup='validatePort(this);' class='inputText' value='" . $logConfigs['RemoteLogPort'] . "' id='RemoteLogPort' /></td>";
        $buff .= '<td>' . getSelectorLoadService( 'klogserver' ) . '</td></tr>';

        $buff .= "<tr><td>Khomp API Server</td>";
        $buff .= "<td><input type='text' onkeypress='return portMask(this, event);' onkeyup='validatePort(this);' class='inputText' value='" . $sysYAML->getValue( 'K3LServerPort' ) . "' id='K3LServerPort' /></td>";
        $buff .= '<td>' . getSelectorLoadService( 'k3lserver' ) . '</td></tr>';

        $buff .= "<tr><td>Khomp Web Portal</td>";
        $buff .= "<td> 14100 </td>";
        $buff .= '<td>' . getSelectorLoadService( 'kwebportal' ) . '</td></tr>';

        $buff .= "<tr><td>Khomp Integrated Boot System</td>";
        $buff .= "<td> (UDP) 14102 </td>";
        $buff .= '<td>' . getSelectorLoadService( 'kibs' ) . '</td></tr>';

        $buff .= "<tr><td>Khomp Watcher Service</td>";
        $buff .= '<td> - </td><td>' . getSelectorLoadService( 'kwatcher' ) . '</td></tr>';

        $buff .= "<tr><td>Khomp Query Server</td>";
        $buff .= "<td><input type='text' onkeypress='return portMask(this, event);' onkeyup='validatePort(this);' class='inputText' value='" . $sysYAML->getValue( 'K3LQueryPort' ) . "' id='K3LQueryPort' /></td>";
        $buff .= '<td>' . getSelectorLoadService( 'kqueryserver' ) . '</td></tr></tbody>';
        $buff .= "</table>";

        $buff .= '</fieldset></br>';
        $buff .= "<div class='textAlignRight'>";
        $buff .= "<input id='saveServicesB' type='button' onclick=\"saveServices('services');\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= '</div><br></div>';

        return $buff;
    }

    function saveServices( $_REQUEST )
    {
        Global $sistema;
        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        if( isset( $data ) )
        {

            $load = array( 'load-kmpserver', 'load-klogserver', 'load-k3lserver', 'load-kwebportal', 'load-kibs', 'load-kwatcher', 'load-kqueryserver' );
            $port = array( 'MediaServerPort', 'RemoteLogPort', 'K3LServerPort', 'K3LQueryPort' );
            $data = explode( ',', $data );

            $SystemYAML = loadSystemYAML( );
            $YAMLchanged = false;
            foreach( $data as $value )
            {
                $cv = explode( ':', $value );
                if( in_array( $cv[0], $load ) )
                {
                    $serviceName = substr( $cv[0], 5 );
                    $service = new Kservice( $serviceName );
                    $service->changeStartup( $cv[1] );
                }
                else if( in_array( $cv[0], $port ) )
                {
                    if( $cv[0] == 'RemoteLogPort' )
                    {
                        $logConfigs = loadKLogConfigs( );

                        if( $logConfigs['RemoteLogPort'] != $cv[1] )
                        {
                            $configDir = $sistema->getConfigDir( );
                            $fileContent = file( $configDir . '/klog.cfg' );
                            for( $x = 0; $x < sizeof( $fileContent ); $x++ )
                            {
                                if( @ereg( "\[", $fileContent[$x] ) )
                                {
                                    $sectionName = explode( "]", $fileContent[$x] );
                                    $sectionName = explode( "[", $sectionName[0] );
                                    $sectionName = $sectionName[1];
                                }
                                elseif( @ereg( "=", $fileContent[$x] ) )
                                {
                                    $varName = explode( "=", $fileContent[$x] );
                                    if( $varName[0] == 'RemoteLogPort' )
                                        $fileContent[$x] = $varName[0] . "=" . trim( $cv[1] ) . "\n";
                                    else
                                        $fileContent[$x] = $varName[0] . "=" . trim( $varName[1] ) . "\n";
                                }
                            }
                            $content = implode( "", $fileContent );
                            $pFile = fopen( $configDir . '/klog.cfg', "w+" );
                            fwrite( $pFile, $content );
                            fclose( $pFile );
                        }
                    }
                    else
                    {
                        $SystemYAML->yaml['Network'][$cv[0]] = $cv[1];
                        $YAMLChanged = true;
                    }
                }
            }
            if( $YAMLChanged )
                $SystemYAML->save( );

            return $sistema->retTranslate( 'servicesChanged' );
        }

    }

    function showKIBS( $_REQUEST )
    {
        Global $sistema;

        $buff = '';
        $buff .= '<div id="KIBS">';
        $buff .= '<fieldset>';
        $buff .= "<legend>Khomp Integrated Boot System</legend>";
        $interfaces = $sistema->getIPv4Interfaces( );

        $newKibs = new KKibs( );
        $kibsInterfaces = $newKibs->getKibsInterfaces( );
        $buff .= '<div id="kibsinterfaces">' . $sistema->retTranslate( 'kibsinterface' ) . '</div><br>';
        $buff .= '<div id="allInterfaces">';
        $buff .= '<table id="tableKIBSInterfaces" class="simpleTable" ><tbody>';

        // ugly but need to wait until the kwebhelper works with  win
        if( PHP_OS == "WINNT" )
        {
            $maxInterfaces = sizeof( $interfaces );
            if( $maxInterfaces > 0 )
            {
                for( $i = 0; $i < $maxInterfaces; $i++ )
                {
                    $checked =  !in_array( $interfaces[$i], $kibsInterfaces ) ? '' : 'checked';
                    $buff .= "<tr><td><input class='check KIBSinterface' type='checkbox' name='kibsinterface{$i}' id='kibsinterface{$i}' value='" . $interfaces[$i] . "' {$checked}> ";
                    $buff .= "<label class='cursorHand' for='kibsinterface{$i}'>". $interfaces[$i] . '</label></td>';
                    $buff .= '</tr>';
                }
                $buff .= '</tbody></table><br/>';
                $buff .= '<a onclick="checkAllInterfaces();" href="#">' . $sistema->retTranslate( 'all' ) . '</a></div><br>';
            }
            else
                $buff .= '<span id="noNetworkInterface">' . $sistema->retTranslate( 'noNetworkInterface' ) . '</span>';
        }
        else
        {

            $maxInterfaces = sizeof( $interfaces );
            if( $maxInterfaces > 0 )
            {
                foreach ($interfaces as $k => $v)
                {
                    $checked =  !in_array( $v, $kibsInterfaces ) ? '' : 'checked';
                    $buff .= "<tr><td><input class='check KIBSinterface' type='checkbox' name='kibsinterface{$k}' id='kibsinterface{$k}' value='" . $v . "' {$checked}> ";
                    $buff .= "<label class='cursorHand' for='kibsinterface{$k}'>". $v . '</label></td>';
                    $buff .= '</tr>';
                }
                $buff .= '</tbody></table><br/>';
                $buff .= '<a onclick="checkAllInterfaces();" href="#">' . $sistema->retTranslate( 'all' ) . '</a></div><br>';
            }
            else
                $buff .= '<span id="noNetworkInterface">' . $sistema->retTranslate( 'noNetworkInterface' ) . '</span>';
        }

        $buff .= '</fieldset>';
        $buff .= '</br>';

        $buff .= '<div class="textAlignRight">';
        $buff .= '<input id="saveKIBSB" type="button" onclick="saveKIBS();" value="' . $sistema->retTranslate('save'). '" />';
        $buff .= '</div>';
        $buff .= '<br>';
        $buff .= '</div>';

        return $buff;
    }

    function saveKIBS( $_REQUEST )
    {
        Global $sistema;
        $interfaces = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        if( isset( $interfaces ) )
        {
            $KIBSYAML = loadKIBSYAML( );
            $yaml = $KIBSYAML->getYaml( );
            $interfaces_arr = $interfaces != '' ? explode( ',', $interfaces ) : array( );
            $newKibs = new KKibs( );
            $newKibs->createInterfaces( $interfaces_arr );

            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    function showMediaServer( $_REQUEST )
    {
        Global $sistema;

        $buff = '';

        $sysYAML = loadSystemYaml( );

        $buff .= "<div id='KMP' >";
        $buff .= "<fieldset>";
        $buff .= "<legend>" . $sistema->retTranslate( 'Media-Server' ) . "</legend>";

        $buff .= "<table class='zebra'><tbody>";
        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'DspThreadCount' ) . "</td>";
        $buff .= "<td align='right'>";
        $buff .= "<input id='DspThreadCount' class='inputText' type='text' onkeypress='return portMask(this, event);' onkeyup='validatePort(this);' value='" . $sysYAML->getValue( 'DspThreadCount' ) . "' name='DspThreadCount'>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'LocalAudioInterface' ) . "</td>";
        $buff .= "<td align='right'>";
        $value = $sysYAML->getValue( 'LocalAudioInterface', 'Network' );
        $buff .= "<input id='LocalAudioInterface' class='inputText' type='text' onkeydown='return maskIP(event, this);' onkeyup='validateIP(this);' value='" . $value . "' name='LocalAudioInterface'>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'LocalAudioPort' ) . "</td>";
        $buff .= "<td align='right'>";
        $buff .= "<input id='LocalAudioPort' class='inputText' type='text' onkeypress='return portMask(this, event);' onkeyup='validatePort(this);' value='" . $sysYAML->getValue( 'LocalAudioPort' ) . "' name='LocalAudioPort'>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'MinAudioPort' ) . "</td>";
        $buff .= "<td align='right'>";
        $buff .= "<input id='MinAudioPort' class='inputText' type='text' onkeypress='return portMask(this, event);' onkeyup='validatePort(this);' value='" . $sysYAML->getValue( 'MinAudioPort' ) . "' name='MinAudioPort'>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'MaxAudioPort' ) . "</td>";
        $buff .= "<td align='right'>";
        $buff .= "<input id='MaxAudioPort' class='inputText' type='text' onkeypress='return portMask(this, event);' onkeyup='validatePort(this);' value='" . $sysYAML->getValue( 'MaxAudioPort' ) . "' name='MaxAudioPort'>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "</tbody></table>";
        $buff .= "</fieldset>";
        $buff .= '</br>';

        $buff .= "<div class='textAlignRight'>";
        $buff .= "<input id='saveMediaServerB' type='button' onclick=\"saveMediaServer();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        $buff .= "</div>";

        return $buff;
    }

    function saveMediaServer( $_REQUEST )
    {
        Global $sistema;

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        if( isset( $data ) )
        {
            $sysYAML = loadSystemYaml( );
            $data_arr = explode( ',', $data );
            $r = '';

            foreach( $data_arr as $d )
            {
                $field = explode( '=', $d );
                $sysYAML->changeVarValue( $field[0], $field[1] );
            }

            $sysYAML->save( );
            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    function showVoIPOptions( $_REQUEST, $section = null )
    {
        Global $sistema;

        $app = KSystem::getInstance();

        $buff = '';
        $buff .= "<div id='VoIPopcoes'>";
        $buff .= "<fieldset>";
        $buff .= "<legend>VoIP</legend>";

        $sysYAML = isset( $_SESSION['systemYAML'] ) ? unserialize( $_SESSION['systemYAML'] ) : loadSystemYaml( );

        $buff .= "<table class='zebra'><tbody>";
        $buff .= "<tr><td align='left'><label for='MaxRtp'>" . $app->translate( 'MaiorPortaRTP' ) . "</label></td>";
        $buff .= "<td align='right'>";
        $buff .= "<input id='MaxRtp' class='inputText' type='text' onkeypress='return portMask(this, event)' onkeyup='validatePort(this);' value='" . $sysYAML->getValue( 'MaxRtp' ) . "' name='MaxRtp'>";
        $buff .= "</td>";
        $buff .= "</tr>";
        $buff .= "<tr><td align='left'><label for='MinRtp'>" . $app->translate( 'MenorPortaRTP' ) . "</label></td>";
        $buff .= "<td align='right'>";
        $buff .= "<input id='MinRtp' class='inputText' type='text' onkeypress='return portMask(this, event);'onkeyup='validatePort(this);' value='" . $sysYAML->getValue( 'MinRtp' ) . "' name='MinRtp'>";
        $buff .= "</td>";
        $buff .= "</tr>";
        $buff .= "<tr><td align='left'><label for='ListenPort'>" . $app->translate( 'PortaGateway' ) . "</label></td>";
        $buff .= "<td align='right'>";
        $buff .= "<input id='ListenPort' class='inputText' type='text' onkeypress='return portMask(this, event);' onkeyup='validatePort(this);' value='" . $sysYAML->getValue( 'ListenPort' ) . "' name='ListenPort'>";
        $buff .= "</td>";
        $buff .= "</tr>";
        $checked = $sysYAML->getValue( 'ReplaceEscapedChars' ) == 'true' || $sysYAML->getValue( 'ReplaceEscapedChars' ) == 'yamlError'? ' checked=\'checked\'' : '';
        $buff .= "<tr><td align='left'><label for='ReplaceEscapedChars'>" . $app->translate( 'ReplaceEscapedChars' ) . "</label></td>";
        $buff .= "<td class='gateway-form-field-container-right form-checkbox-alone'>";
        $buff .= "<input id='ReplaceEscapedChars' type='checkbox' name='ReplaceEscapedChars'{$checked}>";
        $buff .= "</td>";
        $buff .= "</tr>";
        $checked = $sysYAML->getValue( 'IgnoreContactAddress' ) == 'true' ? ' checked=\'checked\'' : '';
        $buff .= "<tr><td align='left'><label for='IgnoreContactAddress'>" . $app->translate( 'IgnoreContactAddress' ) . "</label></td>";
        $buff .= "<td class='gateway-form-field-container-right form-checkbox-alone'>";
        $buff .= "<input id='IgnoreContactAddress' type='checkbox' name='IgnoreContactAddress'{$checked}>";
        $buff .= "</td>";
        $buff .= "</tr>";
        $checked = $sysYAML->getValue( 'UsePRACK' ) == 'true' || $sysYAML->getValue( 'UsePRACK' ) == 'yamlError' ? ' checked=\'checked\'' : '';
        $buff .= "<tr><td align='left'><label for='UsePRACK'>" . $app->translate( 'UsePRACK' ) . "</label></td>";
        $buff .= "<td class='gateway-form-field-container-right form-checkbox-alone'>";
        $buff .= "<input id='UsePRACK' type='checkbox' name='UsePRACK'{$checked}>";
        $buff .= "</td>";
        $buff .= "</tr>";
        $checked = $sysYAML->getValue( 'IgnoreEndOfEvent' ) == 'true' ? ' checked=\'checked\'' : '';
        $buff .= '<tr><td align="left"><label for="IgnoreEndOfEvent">' . $app->translate( 'IgnoreEndOfEvent' ) . '</label></td>';
        $buff .= "<td class='gateway-form-field-container-right form-checkbox-alone'>";
        $buff .= "<input id='IgnoreEndOfEvent' type='checkbox' name='IgnoreEndOfEvent'{$checked}>";
        $buff .= '</td>';
        $buff .= '</tr>';
        $EnableRtcp = $sysYAML->getValue( 'EnableRtcp' );
        $checked = $EnableRtcp == 'yamlError' || $EnableRtcp == 'true' ? ' checked' : '';
        $buff .= '<tr><td align="left"><label for="EnableRtcp">' . $app->translate( 'EnableRtcp' ) . '</label></td>';
        $buff .= "<td class='gateway-form-field-container-right form-checkbox-alone'>";
        $buff .= "<input id='EnableRtcp' type='checkbox' name='EnableRtcp'{$checked}>";
        $buff .= '</td>';
        $buff .= '</tr>';

        if( IS_GATEWAY )
        {
            $gatewayyaml = new KGatewayYaml( );

            if( KFeatures::checkFeature( 'TRANSCODING_CONFIG' ) )
            {
                $transcodingMode = $gatewayyaml->getSettingsSIP( );
                $enabled = $transcodingMode['TranscodingMode'] == 'true' ? ' checked=\'checked\'' : '';
                $buff .= '<tr><td align="left"><label for="TranscodingMode">' . $app->translate( 'TranscodingMode' ) . '</label></td>';
                $buff .= "<td class='gateway-form-field-container-right form-checkbox-alone'>";
                $buff .= "<input id='TranscodingMode' type='checkbox' name='TranscodingMode'{ $enabled }/>";
                $buff .= '</td>';
                $buff .= '</tr>';
            }
        }

        $buff .= '<tr><td align="left"><label for="TelephoneEventPayloadType">' . $app->translate( 'TelephoneEventPayloadType' ) . '</label></td>';
        $buff .= '<td align="right">';
        $TelephoneEventPayloadType = $sysYAML->getValue( 'TelephoneEventPayloadType' ) != 'yamlError' ? $sysYAML->getValue( 'TelephoneEventPayloadType' ) : 100;
        $buff .= '<select id="TelephoneEventPayloadType" name="TelephoneEventPayloadType">';

        for( $x = 96; $x <= 127; $x++ )
        {
            $selected = ($x == $TelephoneEventPayloadType) ? 'selected' : '';
            $buff .= "<option value='$x' $selected>$x</option>";
        }
        $buff .= '</select></td>';
        $buff .= '</td>';
        $buff .= '</tr>';

        $buff .= '<tr><td align="left"><label for="SipTransportType">' . $app->translate( 'SipTransportType' ) . '</label></td>';
        $buff .= '<td align="right">';
        $fieldValue = $sysYAML->getValue( 'SipTransportType' );
        $SipTransportType  = $fieldValue != 'yamlError' ? $fieldValue : '0x00';
        $buff .= '<select id="SipTransportType" name="SipTransportType">';
        $possibleValues = array('UDP' => '0', 'TCP' =>'1', 'TLS' => '2');
        foreach ($possibleValues as $k => $v)
        {
            $selected = ($v == $SipTransportType) ? 'selected' : '';
            $buff .= "<option value='$v' $selected>$k</option>";
        }
        $buff .= '</select></td></td></tr>';

        $buff .= '<tr><td align="left"><label for="AudioTransportType">' . $app->translate( 'AudioTransportType' ) . '</label></td>';
        $buff .= '<td align="right">';
        $fieldValue = $sysYAML->getValue( 'AudioTransportType' );
        $AudioTransportType = $fieldValue != 'yamlError' ? $fieldValue : '0x00';
        $buff .= '<select id="AudioTransportType" name="AudioTransportType">';
        $possibleValues = array('UDP' => '0', 'TCP' =>'1', 'SRTP' => '2');
        foreach ($possibleValues as $k => $v)
        {
            $selected = ($v == $AudioTransportType ) ? 'selected' : '';
            $buff .= "<option value='$v' $selected>$k</option>";
        }
        $buff .= '</select></td></td></tr>';

        $buff .= "<tr><td align='left'><label for='UriUserParam'>" . $app->translate( 'UriUserParam' ) . "</label></td>";
        $buff .= "<td align='right'>";
        $fieldValue = $sysYAML->getValue( 'UriUserParam' );
        $UriUserParam = $fieldValue != 'yamlError' ? $fieldValue : '0';
        $buff .= '<select id="UriUserParam" name="UriUserParam">';
        $possibleValues = array('none' => '0', 'Phone' =>'1', 'IP' => '2');
        foreach ($possibleValues as $k => $v)
        {
            $selected = ($v == $UriUserParam) ? 'selected' : '';
            $buff .= "<option value='$v' $selected>" . $app->translate($k) . "</option>";
        }
        $buff .= '</select></td></td></tr>';

        $buff .= "<tr><td align='left'><label for='NetworkPacketSize'>" . $app->translate( 'TamanhoPacoteAudio' ) . "</label></td>";
        $buff .= "<td align='right' width='15%'>";
        $NetworkPacketSize = $sysYAML->getValue( 'NetworkPacketSize' );
        $buff .= "<select id='NetworkPacketSize' name='NetworkPacketSize'>";
        for( $x = 8; $x <= 160; $x++ )
        {
            $selected = ($x == $NetworkPacketSize) ? "selected" : '';
            $buff .= "<option value='$x' $selected>$x</option>";
        }
        $buff .= "</select></td>";
        $buff .= "</td>";
        $buff .= "</tr>";

        if( !IS_GATEWAY )
        {

            $buff .= "<tr><td align='left'><label for='Proxy'>" . $app->translate( 'ProxyPadrao' ) . "</label></td>";
            $buff .= "<td align='right'>";
            $buff .= '<input id="Proxy" class="inputText" type="text" onkeydown="return maskIP(event, this);" onkeyup="validateIP(this);" value="' . $sysYAML->getValue( 'Proxy' ) . '" name="Proxy">';
            $buff .= "</td>";
            $buff .= "</tr>";

            $buff .= "<tr><td align='left'><label for='VoIPDeviceSerial'>" . $app->translate( 'VoIPDeviceSerial' ) . "</label></td>";
            $buff .= "<td align='right'>";
            $buff .= "<input id='VoIPDeviceSerial' class='inputText' type='text' onkeypress='return portMask(this, event)' onmouseup='return portMask(this, event)' onkeyup='validatePort(this);' value='" . $sysYAML->getValue( 'VoIPDeviceSerial' ) . "' name='VoIPDeviceSerial'>";
            $buff .= "</td>";
            $buff .= "</tr>";
        }
        $buff .= "</tbody></table>";
        $buff .= '</br>';

        if(!IS_GATEWAY)
        {
            $buff .= '<div class="VoIPInterface-holder">';
            $SIP = $sysYAML->getValue( 'SipInterface' );
            $SIP_arr = gettype($SIP) == 'string' ? array($SIP) : $SIP;
            $buff .= '<fieldset><legend>SIP Interface</legend>';
            $buff .= '<div class="textAlignCenter">' . $app->translate( 'dragSIPInterface' ) . '</div>';
            $buff .= '<ul id="SipInterface" class="Interface-holder" >';
            $interfaces = $sistema->getAllInterfaces();
            $arr = array_unique(array_merge($SIP_arr, $interfaces));
            foreach ($arr as $k => $v)
            {
                if(PHP_OS != "WINNT" )
                {
                    if(strpos($v, ';') > -1)
                    {
                        $tmp_arr = explode(';', $v);
                        $v = strtoupper($tmp_arr[0]);
                    }
                    else
                        $v = strtoupper($v);
                }
                else
                    $v = strtoupper($v);

                if(trim($v) != '')
                {
                    $checked = in_array($v, $SIP_arr) ? 'checked' : '';
                    $buff .= "<li ><input class='voip' {$checked} value='{$v}' type='checkbox' id='sip-iface-{$k}'><label for='sip-iface-{$k}'>{$v}</label></li>";
                }
            }
            $buff .= '</ul>';
            $buff .= '</fieldset>';

            $RTP = $sysYAML->getValue( 'RtpInterface' );
            $RTP_arr = gettype($RTP) == 'string' ? array($RTP) : $RTP;
            $buff .= '<fieldset><legend>RTP Interface</legend>';
            $buff .= '<div class="textAlignCenter">' . $app->translate( 'dragRTPInterface' ) . '</div>';
            $buff .= '<ul id="RtpInterface" class="Interface-holder" >';
            // $interfaces = $sistema->getAllInterfaces();
            $arr = array_unique(array_merge($RTP_arr, $interfaces));
            foreach ($arr as $k => $v)
            {
                if(PHP_OS != "WINNT" )
                {
                    if(strpos($v, ';') > -1)
                    {
                        $tmp_arr = explode(';', $v);
                        $v = strtoupper($tmp_arr[0]);
                    }
                    else
                        $v = strtoupper($v);
                }
                else
                    $v = strtoupper($v);

                if(trim($v) != '')
                {
                    $checked = in_array($v, $RTP_arr) ? 'checked' : '';
                    $buff .= "<li><input class='voip' {$checked} value='{$v}' type='checkbox' id='rtp-iface-{$k}'><label for='rtp-iface-{$k}'>{$v}</label></li>";
                }
            }
            $buff .= '</ul>';
            $buff .= '</fieldset>';
            $buff .= '</div>';
            $buff .= '</br></br>';
        }

        if ( !IS_GATEWAY )
        {
        $buff .= '<label class="labelTLS">TLS</label>';
        $buff .= "<table class='zebra'><tbody>";

        $buff .= "<tr><td align='left'><label for='PrivateKeyFile'>".$app->translate('PrivateKeyFile')."</label></td>";
        $buff .= "<td align='right'>";
        $privKey = $sysYAML->getValue( 'PrivateKeyFile' ) == 'yamlError' ? '' :  $sysYAML->getValue( 'PrivateKeyFile' );
        $buff .= "<input id='PrivateKeyFile' class='inputTextLong' type='text' value='{$privKey}' name='PrivateKeyFile'>";
        $buff .= "</td></tr>";

            $buff .= "<tr><td align='left'><label for='CertificateFile'>".$app->translate('CertificateFile')."</label></td>";
            $buff .= "<td align='right'>";
            $certificate = $sysYAML->getValue( 'CertificateFile' ) == 'yamlError' ? '' :  $sysYAML->getValue( 'CertificateFile' );
            $buff .= "<input id='CertificateFile' class='inputTextLong' type='text' value='{$certificate}' name='CertificateFile'>";
            $buff .= "</td></tr>";

        $buff .= "<tr><td align='left'><label for='CAFile'>".$app->translate('CAFile')."</label></td>";
        $buff .= "<td align='right'>";
        $CAFile = $sysYAML->getValue( 'CAFile' ) == 'yamlError' ? '' :  $sysYAML->getValue( 'CAFile' );
        $buff .= "<input id='CAFile' class='inputTextLong' type='text' value='{$CAFile}' name='CAFile'>";
        $buff .= "</td></tr>";

        $checked = $sysYAML->getValue( 'ClientCertificateVerification' ) == 'false' || $sysYAML->getValue( 'ClientCertificateVerification' ) == 'yamlError' ? '' : 'checked=\'checked\'' ;
        $buff .= "<tr><td align='left'><label for='ClientCertificateVerification'>".$app->translate('ClientCertificateVerification')."</label></td>";
        $buff .= "<td class='gateway-form-field-container-right form-checkbox-alone'>";
        $buff .= "<input id='ClientCertificateVerification' type='checkbox' name='ClientCertificateVerification' {$checked}>";
        $buff .= "</td></tr>";
        $buff .= "</table>";

        $buff .= '</br>';
        }

        $buff .= '<label class="labelTLS">Timers</label>';
        $buff .= "<table class='zebra'><tbody>";
        $buff .= "<tr><td align='left'><label for='TimerH'>" . $app->translate( 'TimerH' ) . "</label></td>";
        $buff .= "<td align='right' width='15%'>";
        $THV = $sysYAML->getValue( 'TimerH' );
        $TimerH = $THV != 'yamlError' ? $THV : '32000';
        $buff .= "<select id='TimerH' name='TimerH'>";
        for( $x = 1000; $x <= 60000; $x+=1000 )
        {
            $selected = ($x == $TimerH) ? "selected" : '';
            $buff .= "<option value='$x' $selected>$x</option>";
        }
        $buff .= "</select></td></td></tr>";
        $buff .= "<tr><td align='left'><label for='AckAfter2xx'>" . $app->translate( 'AckAfter2xx' ) . "</label></td>";
        $buff .= "<td align='right' width='15%'>";
        $AA2 = $sysYAML->getValue( 'AckAfter2xx' );
        $AckAfter2xx = $AA2 != 'yamlError' ? $AA2 : '32000';
        $buff .= "<select id='AckAfter2xx' name='AckAfter2xx'>";
        for( $x = 1000; $x <= 60000; $x+=1000 )
        {
            $selected = ($x == $AckAfter2xx) ? "selected" : '';
            $buff .= "<option value='$x' $selected>$x</option>";
        }
        $buff .= "</select></td></td></tr>";
        $buff .= "</table>";

        $buff .= "</fieldset>";
        $buff .= '</br>';

        $buff .= "<div class='textAlignRight'>";
        $buff .= "<input id='saveVoIPOptionsB' type='button' onclick=\"saveVoIPOptions();\" value='" . $app->translate( 'save' ) . "' />";
        $buff .= "</div>";
        $buff .= "</div>";

        return $buff;
    }

    function saveVoIPOptions( $_REQUEST )
    {
        $app = KSystem::getInstance();
        $saveTranscode = true;

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;
        if( isset( $data ) )
        {
            $sysYAML = loadSystemYaml( );
            $data_arr = explode( ',', $data );

            foreach( $data_arr as $d )
            {
                $field = explode( '=', $d );

                switch ($field[0])
                {
                    case 'TimerH':
                    case 'AckAfter2xx':
                        $section = 'VoIP|Timers';
                        break;

                    case 'RtpInterface':
                    case 'SipInterface':

                    $field[1] = $field[1] == '' ? array() : explode('|', $field[1]);

                    /*
                     *  Do not need to validate, user do not need to enter IP.
                     *  But I will keep this pretty awesome regex for the future :)
                     *
                        if(function_exists('filter_var'))
                        {
                             $validIPV4 = filter_var($field[1], FILTER_VALIDATE_IP, FILTER_FLAG_IPV4) == FALSE ? FALSE : TRUE;
                             $validIPV6 = filter_var($field[1], FILTER_VALIDATE_IP, FILTER_FLAG_IPV6) == FALSE ? FALSE : TRUE;
                        }
                        //elastix compability
                        else
                        {
                            $patternIPV4 ='/\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b/';
                            $validIPV4 = preg_match( $patternIPV4, $field[1] ) ? TRUE : FALSE;

                            $patternIPV6 = '/^((([0-9A-Fa-f]{1,4}:){7}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){6}:[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){5}:([0-9A-Fa-f]{1,4}:)?[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){4}:([0-9A-Fa-f]{1,4}:){0,2}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){3}:([0-9A-Fa-f]{1,4}:){0,3}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){2}:([0-9A-Fa-f]{1,4}:){0,4}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){6}((\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b)\.){3}(\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b))|(([0-9A-Fa-f]{1,4}:){0,5}:((\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b)\.){3}(\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b))|(::([0-9A-Fa-f]{1,4}:){0,5}((\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b)\.){3}(\b((25[0-5])|(1\d{2})|(2[0-4]\d)|(\d{1,2}))\b))|([0-9A-Fa-f]{1,4}::([0-9A-Fa-f]{1,4}:){0,5}[0-9A-Fa-f]{1,4})|(::([0-9A-Fa-f]{1,4}:){0,6}[0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}:){1,7}:))$/';
                            $validIPV6 = preg_match( $patternIPV6, $field[1] ) ? TRUE : FALSE;
                        }
                        if($field[1] != '' && (!$validIPV4 && !$validIPV6))
                            return $sistema->retTranslate( $field[0] . 'InvalidIP' );
                     */

                    case 'ReplaceEscapedChars':
                    case 'IgnoreContactAddress':
                    case 'UsePRACK':
                    case 'IgnoreEndOfEvent':
                    case 'EnableRtcp':
                    case 'TelephoneEventPayloadType':
                    case 'SipTransportType':
                    case 'AudioTransportType':
                    case 'CertificateFile':
                    case 'PrivateKeyFile':
                    case 'CAFile':
                    case 'ClientCertificateVerification':
                    case 'UriUserParam':
                    case 'MaxRtp':
                    case 'MinRtp':
                    case 'ListenPort':
                    case 'NetworkPacketSize':
                    case 'Proxy':
                    case 'VoIPDeviceSerial':
                    case 'VoIPDeviceSerial':
                    case 'CustomTonesProfile':
                        $section = 'VoIP';
                        break;
                    case 'TranscodingMode':
                        $saveTranscode = saveTranscodingMode( $field );
                        break;

                    default:
                        return $app->translate( 'VoIPErrorFields' ) . $field[0];
                        break;
                }

                if($sysYAML->getValue( $field[0] ) == 'yamlError' )
                    $sysYAML->createVar( $field[0], $section, $field[1] );
                else
                    $sysYAML->changeVarValue( $field[0], $field[1] );
            }
            if ( $saveTranscode )
            {
            //TODO: port to new Yaml rules model
            $yaml = $sysYAML->getYaml();
            if( $yaml['VoIP']['MaxRtp'] <= $yaml['VoIP']['MinRtp'] )
            {
                return $app->translate( 'voip-save-error-maxrtp-should-be-higher-than-minrtp' );
            }

            //TODO: port to new Yaml rules model
            $yaml = $sysYAML->getYaml();
            if( $yaml['VoIP']['MaxRtp'] <= $yaml['VoIP']['MinRtp'] )
            {
                return $app->translate( 'voip-save-error-maxrtp-should-be-higher-than-minrtp' );
            }

            $sysYAML->save( );
            return $app->translate( 'ConfiguracaoSalva' );
        }
            else
            {
                return $sistema->retTranslate( 'LicencasExcedidas' );
    }
        }
    }

    function showVoIPTLS( $_REQUEST, $section = null )
    {
        $buff = '';

        if ( IS_GATEWAY )
        {
            Global $sistema;

            $app = KSystem::getInstance();

            $sysYAML = isset( $_SESSION['systemYAML'] ) ? unserialize( $_SESSION['systemYAML'] ) : loadSystemYaml( );

            $certificate_file =
                $sysYAML->getValue( 'CertificateFile' ) == 'yamlError'
                    ? '' :  $sysYAML->getValue( 'CertificateFile' );
            $private_key_file =
                $sysYAML->getValue( 'PrivateKeyFile' ) == 'yamlError'
                    ? '' :  $sysYAML->getValue( 'PrivateKeyFile' );
            $ca_file =
                $sysYAML->getValue( 'CAFile' ) == 'yamlError'
                    ? '' :  $sysYAML->getValue( 'CAFile' );
            $verification =
                $sysYAML->getValue( 'ClientCertificateVerification' ) == 'false'
                || $sysYAML->getValue( 'ClientCertificateVerification' ) == 'yamlError'
                ? 'enable' : 'disable' ;

            $verification_label = ( $verification === 'enable' ) ? $app->translate( 'enable' ) : $app->translate( 'disable' ); 

            $buff .= "<div id='VoIPCertificate'>";

            $buff .=    "<fieldset>";
            $buff .=        '<legend>' . $app->translate( 'voip-tls-pagetitle' ) . '</legend>';


            if ( !$private_key_file || !$certificate_file || !$ca_file ) 
            {
                $msgs_help_config = array();

                if ( !$private_key_file )
                {
                    $msgs_help_config[] = $app->translate('tls-text-configure-privatekey');
                }
                if ( !$certificate_file )
                {
                    $msgs_help_config[] = $app->translate('tls-text-configure-certificate');
                }
                if ( !$ca_file )
                {
                    $msgs_help_config[] = $app->translate('tls-text-configure-cafile');
                }

                $buff .= '<div class="form_help_container">';
                $buff .= '<p>' . $app->translate('tls-text-required-configuration-to-activate-crypto') . '</p>';
                $buff .= '<ol><li>' . implode( '</li><li>', $msgs_help_config ) . '</li></ol>';
                $buff .= '</div>';
            }


             /// ------------------------------------------------
            /// Form Private Key

            $buff .= ( $private_key_file == "" ) ? '<form method="POST" name="gateway-voip-private_key">' : '<form method="POST" name="gateway-voip-private_key-remove">';

            $buff .=    "<fieldset>";
            $buff .=        "<legend>".$app->translate('gateway-voip-private_key')."</legend>";

            $buff .=        "<table class='gateway-upload'>";
            $buff .=        "<tbody>";

            $buff .=            "<tr>";
            $buff .=                "<td class='title'>";
            if ( $private_key_file == "" )
            {
                $buff .=                '<input id="gateway-voip-private_key-file" type="file" name="PrivateKeyFile" required="required"/>';
                $buff .=            "</td>";
                $buff .=            "<td class='button'>";
                $buff .=                "<button id='gateway-voip-private_key-send'>";
                $buff .=                    $app->translate('send');
                $buff .=                "</button>";
            }
            else
            {
                $buff .=            '<pre class="tls-summary">' . get_key_summary( $private_key_file ) . '</pre>';
                $buff .=            '<input type="hidden" name="ajaxTo" value="deleteVoIPTLSItem"/>';
                $buff .=            '<input type="hidden" name="remove" value="PrivateKeyFile"/>';
                $buff .=            "</td>";
                $buff .=            "<td class='button'>";
                $buff .=                "<button id='gateway-voip-private_key-remove'>";
                $buff .=                    $app->translate('remove');
                $buff .=                "</button>";
            }
            $buff .=                "</td>";
            $buff .=            "</tr>";

            $buff .=        "</tbody>";
            $buff .=        "</table>";

            $buff .=    "</fieldset>";
            $buff .=    "</form>";


             /// ------------------------------------------------
            /// Form Certificate

            $buff .= ( $certificate_file == "" ) ? '<form method="POST" name="gateway-voip-certificate">' : '<form method="POST" name="gateway-voip-certificate-remove">';
            $buff .=    "<fieldset>";
            $buff .=        "<legend>".$app->translate('gateway-voip-certificate')."</legend>";

            $buff .=        "<table class='gateway-upload'>";
            $buff .=        "<tbody>";

            $buff .=            "<tr>";
            $buff .=                "<td class='title'>";
            if ( $certificate_file == "" )
            {
                $buff .=                '<input id="gateway-voip-certificate-file" type="file" name="CertificateFile" required="required"/>';
                $buff .=            "</td>";
                $buff .=            "<td class='button'>";
                $buff .=                "<button id='gateway-voip-certificate-send'>";
                $buff .=                    $app->translate('send');
                $buff .=                "</button>";
            }
            else
            {
                $certificate_summary = get_certificate_summary( $certificate_file );

                $buff .=            "<div>" . get_certificate_notifications( $certificate_summary ) . "</div>";

                if ( $ca_file && $certificate_file )
                {
                    $buff .=            '<div>' . verify_cafile_vs_certificate( $ca_file, $certificate_file ) . '</div>';
                }

                if ( $private_key_file  && $certificate_file && verify_privatekey_vs_certificate( $private_key_file, $certificate_file ) === false )
                {
                    $buff .= '<div>' . $app->translate( 'tls-error-nomatch-privatekey-vs-certificate' )  . '</div>';
                }

                $buff .=            '<pre class="tls-summary">' . $certificate_summary . '</pre>';
                $buff .=            '<input type="hidden" name="ajaxTo" value="deleteVoIPTLSItem"/>';
                $buff .=            '<input type="hidden" name="remove" value="CertificateFile"/>';
                $buff .=            "</td>";
                $buff .=            "<td class='button'>";
                $buff .=                "<button id='gateway-voip-certificate-remove'>";
                $buff .=                    $app->translate('remove');
                $buff .=                "</button>";
            }
            $buff .=                "</td>";
            $buff .=            "</tr>";

            $buff .=        "</tbody>";
            $buff .=        "</table>";

            $buff .=    "</fieldset>";
            $buff .=    "</form>";


             /// ------------------------------------------------
            /// Form CA File

            $buff .= ( $ca_file == "" ) ? '<form method="POST" name="gateway-voip-ca">' : '<form method="POST" name="gateway-voip-ca-remove">';
            $buff .=    "<fieldset>";
            $buff .=        "<legend>".$app->translate('gateway-voip-ca')."</legend>";

            $buff .=        "<table class='gateway-upload'>";
            $buff .=        "<tbody>";

            $buff .=            "<tr>";
            $buff .=                "<td class='title'>";
            if ( $ca_file == "" )
            {
                $buff .=                '<input id="gateway-voip-ca-file" type="file" name="CAFile" required="required"/>';
                $buff .=            "</td>";
                $buff .=            "<td class='button'>";
                $buff .=                "<button id='gateway-voip-ca-send'>";
                $buff .=                    $app->translate('send');
                $buff .=                "</button>";
            }
            else
            {
                $buff .=            '<pre class="tls-summary">' . get_cafile_summary( $ca_file ) . '</pre>';
                $buff .=            '<input type="hidden" name="ajaxTo" value="deleteVoIPTLSItem"/>';
                $buff .=            '<input type="hidden" name="remove" value="CAFile"/>';
                $buff .=            "</td>";
                $buff .=            "<td class='button'>";
                $buff .=                "<button id='gateway-voip-ca-remove'>";
                $buff .=                    $app->translate('remove');
                $buff .=                "</button>";

            }
            $buff .=                "</td>";
            $buff .=            "</tr>";

            $buff .=        "</tbody>";
            $buff .=        "</table>";

            if ( $ca_file != "" )
            {
            $buff .=     '<table class="zebra">';
            $buff .=        '<tr>';
            $buff .=            '<td class="title" align="left">';
            $buff .=                "<label for='gateway-voip-verify'>";
            $buff .=                    $app->translate('ClientCertificateVerification');
            $buff .=                "</label>";
            $buff .=            "</td>";
            $buff .=            '<td class="button" align="right">';
            $buff .=                "<button id='gateway-voip-verify' value='{$verification}'>";
            $buff .=                    $app->translate($verification_label);
            $buff .=                "</button>";
            $buff .=            "</td>";
            $buff .=        '</tr>';
            $buff .=      '</table>';
            }

            $buff .=    "</fieldset>";
            $buff .=    "</form>";


            $buff .=    "</fieldset>";
            $buff .= "</div>";
        }

        return $buff;
    }

    function saveVoIPTLS( $_REQUEST )
    {
        require_once KROOT . '/json_util.php';

        $app = KSystem::getInstance( );

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        $reply = array(
            'success' => false,
            'message' => $app->translate( 'tls-error-upload' ) 
        );

        if( !empty( $data ) )
        {
            $fieldname = $data[ 'fieldname' ];
            $tmpfilename = $data[ 'tmpfilename' ];

            try
            {
                $reply = array(
                    'success' => true,
                    'message' => $app->translate( 'tls-success-upload-' . $fieldname )
                );

                $sysYAML = loadSystemYaml( );
                $file = '';

                switch ($fieldname)
                {
                case 'CertificateFile':
                    $file = "/etc/khomp/ssl/khomp.crt";
                    break;
                case 'PrivateKeyFile':
                    $file = "/etc/khomp/ssl/khomp.key";
                    break;
                case 'CAFile':
                    $file = "/etc/khomp/ssl/khomp.ca";
                    break;

                default:
                    throw new Exception( 'voip-tls-invalid-field' );
                    break;
                }

                if ( !empty( $file ) )
                {
                    $tmp_file = "/tmp/" . $tmpfilename;

                    if ( file_exists( $tmp_file ) === FALSE )
                    {
                        throw new Exception( 'tls-error-upload' );
                    }

                    if ( !is_dir( dirname( $file ) ) ) 
                    {
                        mkdir( dirname( $file ), 0755, true );
                    }

                    if ( $fieldname === 'PrivateKeyFile' )
                    {
                        if ( key_has_passphrase( $tmp_file ) === true ) 
                        {
                            throw new Exception( 'tls-error-privatekey-should-not-have-passphrase' );
                        }
                        else if ( !key_check( $tmp_file ) )
                        {
                            throw new Exception( 'tls-error-invalid-privatekey' );
                        }
                    }

                    if ( $fieldname === 'CertificateFile' || $fieldname === 'PrivateKeyFile' )
                    {
                        $certfile = $sysYAML->getValue( 'CertificateFile' );
                        $keyfile = $sysYAML->getValue( 'PrivateKeyFile' );

                        if ( empty( $certfile ) || $certfile == 'yamlError' ) 
                        {
                            $certfile = ( $fieldname === 'CertificateFile' ) ? $tmp_file : '';    
                        }

                        if ( empty( $keyfile ) || $keyfile == 'yamlError' ) 
                        {
                            $keyfile = ( $fieldname === 'PrivateKeyFile' ) ? $tmp_file : '';    
                        }

                        if ( verify_privatekey_vs_certificate( $keyfile, $certfile ) === false ) 
                        {
                            throw new Exception( 'tls-error-nomatch-privatekey-vs-certificate' );
                        }
                    }

                    if ( $fieldname === 'CAFile' )
                    {
                        if ( cafile_check( $tmp_file ) === false ) 
                        {
                            throw new Exception( 'tls-error-invalid-cafile' );
                        }
                    }
                    

                    if ( rename( $tmp_file, $file ) === FALSE )
                    {
                        unlink( $tmp_file );

                        throw new Exception( 'tls-error-upload' );
                    }

                }

                if($sysYAML->getValue( $fieldname ) == 'yamlError' )
                    $sysYAML->createVar( $fieldname, 'VoIP', $file );
                else
                    $sysYAML->changeVarValue( $fieldname, $file );

                $sysYAML->save( );
            }
            catch( Exception $e )
            {
                $reply[ 'success' ] = false;
                $reply[ 'message' ] = $app->translate( $e->getMessage( ) );
            }
        }

        return JSONencode( $reply );
    }

    function deleteVoIPTLSItem( $_REQUEST ) 
    {

        $app = KSystem::getInstance( );

        $item = $_REQUEST[ 'remove' ];

        $reply = array(
            'success' => false,
            'message' => $app->translate( 'tls-error-remove-file' )
        );

        try {

            if ( empty( $item ) ) {
                throw new Exception( 'error-item-not-found' );
            }

            $file = '';
            $msg = 'tls-removed-';

            switch ( $item )
            {
            case 'CertificateFile':
                $file = "/etc/khomp/ssl/khomp.crt";
                break;
            case 'PrivateKeyFile':
                $file = "/etc/khomp/ssl/khomp.key";
                break;
            case 'CAFile':
                $file = "/etc/khomp/ssl/khomp.ca";
                break;
            default:
                throw new Exception( 'tls-error-invalid-field' );
                break;
            }

            $sysYAML = loadSystemYaml( );
            $sysYAML->changeVarValue( $item, '' );
            $sysYAML->save();

            if ( file_exists( $file ) ) {
                unlink( $file );
            }

            $reply[ 'success' ] = true;
            $reply[ 'message' ] = $app->translate( $msg . $item );

        } catch ( Exception $e ) {
            $reply[ 'message' ] = $app->translate( $e->getMessage() ) . ': ' . $item;
         }

        return JSONencode( $reply );
    }

    function saveTranscodingMode( $field )
    {
        $gatewayyaml = new KGatewayYaml( );

        if( $field[1] == 'true' )
        {
            $gatewayyaml->setTranscodingMode( $field[1] );
            $gatewayyaml->save( );
            return true;
        }
        else
        {
            $manager = new KLicenseManager( );
            $limitGW = $manager->sumLicensesFieldValue( KLicense::TYPE_GATEWAYVOIPCALLS );

            $license = new KLicenseLimits( );
            $limit = $license->checkVOIPCallsTranscodeOnValue();

            if ( $limitGW <= $limit )
            {
                $gatewayyaml->setTranscodingMode( $field[1] );
                $gatewayyaml->save( );
                return true;
            }

            return false;
        }

    }

    function showVoIPCodecs( $_REQUEST )
    {
        Global $sistema;

        $buff = '';

        if( isset( $_SESSION['systemYAML'] ) )
            $sysYAML = unserialize( $_SESSION['systemYAML'] );
        else
            $sysYAML = loadSystemYaml( );

        $buff .= "<div id='Codecs' >";
        $buff .= "<fieldset>";
        $buff .= "<legend>Codecs</legend>";
        $buff .= "<div id='CodecDrag'>" . $sistema->retTranslate( 'CodecDragMessage' ) . "</div></br></br>";

        $buff .= "<div id='codecList' class='codecList'>";
        $buff .= "<ul id='sortable'>";

        $defaults = array( );
        $defaults = $sysYAML->getValue( 'Codecs' );

        $itens = array( 'DVI4', 'G711U', 'GSM', 'G711A', 'G729A', 'G729B', 'AMR' );

        $unkownCodecConfigured = false;

        for( $x = 0; $x < sizeof( $defaults ); $x++ )
        {
            //retrocompatibility
            $defaults[$x] = ($defaults[$x] == 'G729') ? 'G729B' : $defaults[$x];

            if(in_array($defaults[$x], $itens))
            {
                $buff .= '<li class="ui-state-default" >';
                $buff .= "<input class='check' onclick='verifyCodecs();' type='checkbox' value='$defaults[$x]' checked> ";
                $buff .= $sistema->retTranslate( $defaults[$x] ) . "</li>";
            }
            else
                $unkownCodecConfigured = true;
        }

        for( $y = 0; $y < sizeof( $itens ); $y++ )
        {
            if( !in_array( $itens[$y], $defaults ) )
            {
                $buff .= '<li class="ui-state-default" >';
                $buff .= "<input class='check' onclick='verifyCodecs();' type='checkbox' value='$itens[$y]'> ";
                $buff .= $sistema->retTranslate( $itens[$y] ) . "</li>";
            }
        }
        $buff .= "</ul>";

        $buff .= $unkownCodecConfigured ? '<div class="warning">'.$sistema->retTranslate('unkownCodecConfigured').'</div>' : '';

        $buff .= "</div>";
        $buff .= "</fieldset>";
        $buff .= '</br>';

        $buff .= "<div class='textAlignRight'>";
        $buff .= "<input id='saveVoIPCodecsB' type='button' onclick=\"saveVoIPCodecs();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        $buff .= "<br>";
        $buff .= "</div>";

        return $buff;
    }

    function saveVoIPCodecs( $_REQUEST )
    {

        Global $sistema;

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;
        if( isset( $data ) )
        {
            $sysYAML = loadSystemYaml( );

            if( $data != '' )
                $data_arr = explode( ',', $data );
            else
                $data_arr = array( );

            $sysYAML->changeVarValue( 'Codecs', $data_arr, 'VoIP' );
            $sysYAML->save( );
            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }

    }

    function showAPICompatibility( $_REQUEST )
    {
        Global $sistema;

        $buff = '';

        if( isset( $_SESSION['systemYAML'] ) )
            $sysYAML = unserialize( $_SESSION['systemYAML'] );
        else
            $sysYAML = loadSystemYaml( );

        $buff .= "<div id='API-Compatibility' >";
        $buff .= "<fieldset>";
        $buff .= "<legend>API</legend>";

        $buff .= "<table class='zebra'><tbody>";
        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'DisconnectionConfirmation' ) . "</td>";
        $buff .= "<td width='15%' align='center'>";

        $buff .= "<select id='DisconnectConfirmation' name='DisconnectConfirmation'>";
        $itens = array( 'No', 'Incoming', 'Outgoing', 'Both' );
        $value = $sysYAML->getValue( 'DisconnectConfirmation' );
        for( $y = 0; $y < sizeof( $itens ); $y++ )
        {
            $selected = $value == $itens[$y] ? "selected=''" : '';
            $buff .= "<option $selected value='$itens[$y]'>" . $itens[$y] . "</option>";
        }
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'EnableAudioEvents' ) . "</td>";
        $buff .= "<td width='15%' align='center'>";
        $EnableAudioEvents = $sysYAML->yaml['System']['EnableAudioEvents'] == 'true' ? "checked=''" : '';
        $buff .= "<input id='EnableAudioEvents' $EnableAudioEvents class='check' type='checkbox' value='EnableAudioEvents' name='EnableAudioEvents'>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'ReportAnySingleFrequency' ) . "</td>";
        $buff .= "<td width='15%' align='center'>";
        $ReportAnySingleFrequency = $sysYAML->yaml['System']['ReportAnySingleFrequency'] == 'false' ? '' : "checked=''";
        $buff .= "<input id='ReportAnySingleFrequency' $ReportAnySingleFrequency class='check' type='checkbox' value='ReportAnySingleFrequency' name='ReportAnySingleFrequency'>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'EnableCadenceEvents' ) . "</td>";
        $buff .= "<td width='15%' align='center'>";
        $EnableCadenceEvents = $sysYAML->yaml['System']['EnableCadenceEvents'] == 'true' ? "checked=''" : '';
        $buff .= "<input id='EnableCadenceEvents' class='check' $EnableCadenceEvents type='checkbox' value='EnableCadenceEvents' name='EnableCadenceEvents'>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "</tbody></table>";
        $buff .= "</fieldset>";
        $buff .= '</br>';

        $buff .= "<div class='textAlignRight'>";
        $buff .= "<input id='saveAPICompatibilityB' type='button' onclick=\"saveAPICompatibility();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        $buff .= "<br>";
        $buff .= "</div>";

        return $buff;

    }

    function saveAPICompatibility( $_REQUEST )
    {
        Global $sistema;

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;
        if( isset( $data ) )
        {
            $sysYAML = loadSystemYaml( );

            if( $data != '' )
                $data_arr = explode( ',', $data );
            else
                $data_arr = array( );

            foreach( $data_arr as $data )
            {
                $field = explode( '=', $data );

                if($sysYAML->getValue( $field[0] ) == 'yamlError' )
                    $sysYAML->createVar( $field[0], 'System', $field[1] );
                else
                    $sysYAML->changeVarValue( $field[0], $field[1] );
            }
            $sysYAML->save( );
            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    function showLogsErrorCount( $_REQUEST )
    {
        Global $sistema;
        $buff = '';
        if( isset( $_SESSION['systemYAML'] ) )
            $sysYAML = unserialize( $_SESSION['systemYAML'] );
        else
            $sysYAML = loadSystemYaml( );

        $buff .= "<div id='errosLink'>";
        $buff .= "<fieldset>";
        $buff .= "<legend>" . $sistema->retTranslate( 'errosLink' ) . "</legend>";

        $buff .= "<table class='simpleTable' id='ErrorCounterCheckInterval-table'>";
        $buff .= "<tr>";
        $buff .= "<td width='80%' align='left'>" . $sistema->retTranslate( 'TempoParaVerificacaoContadoresErro' ) . "</td>";
        $buff .= "<td width='20%' align='center'>";
        $ErrorCounterCheckInterval = $sysYAML->getValue( 'ErrorCounterCheckInterval' );
        $buff .= "<select id='ErrorCounterCheckInterval' name='ErrorCounterCheckInterval'>";
        for( $x = 1000; $x <= 60000; $x = $x + 1000 )
        {
            $selected = "";
            if( $x == $ErrorCounterCheckInterval )
                $selected = "selected";
            $buff .= "<option value='$x' $selected>$x</option>";
        }
        $buff .= "</select></td>";
        $buff .= "</td>";
        $buff .= "</tr>";
        $buff .= "</table><br>";
        $buff .= "</span>";

        // $buff .= "<fieldset>";
        $buff .= "<label class='labelTLS'>" . $sistema->retTranslate( 'IgnorarErrosSeguintesContadores' ) . "</label>";


        $buff .= "<table id='tableErrorCounter' class='zebra'><tbody>";

        $itens = array( 'MudancasParaBloqueado', 'PerdaSinal', 'IndicacaoAlarmesRecebidos', 'SincronismoQuadro', 'SincronismoMultiquadro', 'AlarmesRemotosRecebidos', 'AlarmesNaoIdentificados', 'ErrosPBRSDetectados', 'EbitsRecebidosIncorretos', 'VariacaoBrutaJitter', 'TempoSincronismoPerdido', 'ErrosAlinhamentoQuadro', 'QuadrosErrados', 'ViolacaoBipolar', 'ErrosCRC4' );

        $countErr = $sysYAML->getValue( 'IgnoredCounters' );

        for( $x = 0; $x < sizeof( $itens ); $x++ )
        {
            $checked = "";
            if( @in_array( $x, $countErr ) )
                $checked = "checked";

            $buff .= '<tr><td align="left" width="80%">' . $sistema->retTranslate( $itens[$x] ) . '</td>';
            $buff .= "<td align='center' width='20%'>";
            $buff .= "<input class='check' type='checkbox' name='IgnoredCounters$x' id='IgnoredCounters$x' value='IgnoredCounters$x' $checked>";
            $buff .= "</td>";
            $buff .= "</tr>";
        }
        $buff .= "</tbody></table>";

        // $buff .= "</fieldset>";
        $buff .= "</fieldset>";
        $buff .= '</br>';

        $buff .= "<div class='textAlignRight'>";
        $buff .= "<input id='saveLogsErrorCountB' type='button' onclick=\"saveLogsErrorCount();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        $buff .= "<br>";
        $buff .= "</div>";

        return $buff;
    }

    function saveLogsErrorCount( $_REQUEST )
    {
        Global $sistema;

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;
        if( isset( $data ) )
        {
            $sysYAML = loadSystemYaml( );

            if( $data != '' )
                $data_arr = explode( ',', $data );
            else
                $data_arr = array( );

            $field = explode( '=', $data_arr[0] );

            if( isset( $field[1] ) )
                $sysYAML->changeVarValue( $field[0], $field[1] );

            $counters = explode( '=', $data_arr[1] );
            if( $counters[1] != '' )
            {
                $values = explode( ':', $counters[1] );
                $arr = array( );

                for( $i = 0; $i < sizeof( $values ); $i++ )
                {
                    if( $values[$i] == 'true' )
                        $arr[] = $i;
                }
            }
            else
                $arr = array( );

            $sysYAML->changeVarValue( $counters[0], $arr );
            $sysYAML->save( );

            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    function saveVoIPClientCertificateVerification( $_REQUEST )
    {
        require_once KROOT . '/json_util.php';

        $app = KSystem::getInstance( );

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        $reply = array(
            'success' => false,
            'message' => $app->translate( 'error' ) 
        );

        if( !empty( $data ) )
        {
            $fieldname = 'ClientCertificateVerification';
            $value = $data[ $fieldname ];

            try
            {
                $sysYAML = loadSystemYaml( );

                if($sysYAML->getValue( $fieldname ) == 'yamlError' )
                    $sysYAML->createVar( $fieldname, 'VoIP', $value );
                else
                    $sysYAML->changeVarValue( $fieldname, $value );

                $sysYAML->save( );
                $reply = array(
                    'success' => true,
                    'message' => $app->translate( 'configurationSaved' ) 
                );
            }
            catch( Exception $e )
            {
                $reply[ 'success' ] = false;
                $reply[ 'message' ] = $app->translate( $e->getMessage( ) );
            }
        }

        return JSONencode( $reply );
    }

    function exec_cmd( $cmd ) 
    {
        ob_start();
        passthru( $cmd, $exit_code );
        $output = ob_get_contents();
        ob_end_clean();
        return $output;
    }

    function get_certificate_summary( $cert ) 
    {
        $app = KSystem::getInstance();
        $summary = exec_cmd( 'openssl x509 -noout -dates -fingerprint -issuer  -in ' . $cert );

        return ( empty( $summary ) ) ? $app->translate( 'tls-error-invalid-certificate' ) : $summary;
    }

    function get_certificate_notifications( $certificate_details ) 
    {
        if ( empty( $certificate_details ) ) return '';

        preg_match( '/notAfter=(.+)/', $certificate_details, $matches );

        if ( empty( $matches ) ) return '';

        $not_after_timestamp = strtotime( $matches[ 1 ] );
        $actual_timestamp = mktime();

        $notify = '';
        $app = KSystem::getInstance();
        $time_diff = $not_after_timestamp - $actual_timestamp;

        if ( $time_diff  < 0 )
        {
            $notify = '<span class="msg-alert">' . $app->translate( 'certificate-expired' ) . '</span>'; 
        }
        else if ( $time_diff  < 45 * 24 * 60 * 60 )
        {
            $notify = '<span class="msg-alert">' . $app->translate( 'certificate-will-expire-soon' ) . '</span>'; 
        }

        return $notify;
     }

    function verify_privatekey_vs_certificate( $key, $cert ) 
    {

        if ( empty( $cert ) || empty( $key ) ) {
            return null;
        }

        $pkey_pubkey = exec_cmd( 'openssl pkey -pubout -in ' . $key );
        $cert_pubkey = exec_cmd( 'openssl x509 -noout -pubkey -in ' . $cert );

        return ( !empty( $pkey_pubkey ) && !empty( $cert_pubkey ) && $pkey_pubkey === $cert_pubkey ) ? true : false;
    }

    function key_has_passphrase( $key )
    {
        return ( exec_cmd( 'cat ' . $key . ' | grep Proc-Type' ) ) ? true : false;
    }

    function key_check( $file )
    {
        $check = exec_cmd( 'openssl rsa -noout -check -in ' . $file );
        return ( empty( $check ) ) ? false : $check;
    }

    function cafile_check( $file )
    {
        $check = exec_cmd( 'openssl x509 -noout -dates -fingerprint -issuer -in ' . $file );

        return ( empty( $check ) ) ? false : $check;
    }

    function get_key_summary( $key )
    {
        $app = KSystem::getInstance();

        $summary = exec_cmd( 'openssl rsa -noout -check -in ' . $key );

        return ( empty( $summary ) ) ? '<span class="msg-alert">' . $app->translate( 'tls-error-invalid-privatekey' ) . '</span>': $summary;
    }

    function get_cafile_summary( $cafile ) 
    {
        $app = KSystem::getInstance();

        $summary = cafile_check( $cafile );

        return ( empty( $summary ) ) ? $app->translate( 'tls-error-invalid-cafile' ): $summary;
    }

    function verify_cafile_vs_certificate( $cafile, $certificate ) 
    {
        if ( empty( $certificate ) || empty( $cafile ) )
        {
            return '';
        }

        $app = KSystem::getInstance();

        $summary = exec_cmd( 'openssl verify -CAfile ' . $cafile . ' ' . $certificate );

        $summary = str_replace( $certificate.':', '', $summary );

        return ( trim( $summary ) === 'OK' ) ? '' : '<span class="msg-alert">' . $app->translate('tls-error-ca-vs-certificate') . '</span>';
    }

