<?php
    require_once KCONFIG . '/classes/classKYaml.php';

    class KGatewayFTPYamlException extends KYamlException
    {
        /* VOID */
    }

    class KFTPYaml extends KYaml
    {	
		public function __construct( )
        {
    		$this->rules = array(
    			'FTP' => array(
                    'type' => KYaml::TYPE_LISTHASH,
                    'children' => array(
                    	'Enabled' => array(
                        	'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_NORMALIZE,
                            'type' => KYaml::TYPE_BOOLEAN,
                            'default' => false
                         ),
                    	'Server' => array(
                        	'type' => KYaml::TYPE_STRING,
                        	'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_NORMALIZE
                         ),
                       	'Port' => array(
                        	'type' => KYaml::TYPE_INTEGER,
                        	'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_NORMALIZE
                         ),
                    	'User' => array(
                        	'type' => KYaml::TYPE_STRING,
                        	'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_NORMALIZE
                         ),
                    	'Passwd' => array(
                        	'type' => KYaml::TYPE_STRING,
                        	'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_NORMALIZE
                         ),
                    	'Path' => array(
                        	'type' => KYaml::TYPE_STRING,
                        	'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_NORMALIZE
                         )
			        )
				),
				'CDR' => array(
                    'type' => KYaml::TYPE_LISTHASH,
                    'children' => array(
                    	'Retention' => array(
                        	'type' => KYaml::TYPE_INTEGER,
                        	'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_NORMALIZE,
                        	'default' => 30
                         ),
                       	'Size' => array(
                        	'type' => KYaml::TYPE_INTEGER,
                        	'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_NORMALIZE,
                        	'default' => 1024000
                         )
					)
				)
			);
			
			//@formatter:on

            $app = KSystem::getInstance( );
            parent::__construct( $app->getConfigDir( ) . DIRECTORY_SEPARATOR . 'gatewayftp.yaml' );
		}

		public function getFTP( )
        {
            return $this->yaml['FTP'];
        }

        public function setFTP( $data )
        {
            $currentData = $this->getFTP( );
            $this->yaml['FTP'] = $data;
        }
		
		public function getCDRFTP( )
        {
            return $this->yaml['CDR'];
        }
		
		public function setCDRFTP( $data )
        {
            $currentData = $this->getCDRFTP( );
            $this->yaml['CDR'] = $data;
        }				
}