<?php
    @session_start( );
    $AjaxFunctions['updateDataChannels'] = 'updateDataChannels';

    function updateDataChannels( $_REQUEST )
    {
        $app = KSystem::getInstance( );
        $link = isset( $_REQUEST['linkNow'] ) ? $_REQUEST['linkNow'] : NULL;
        $board = isset( $_REQUEST['boardNow'] ) ? $_REQUEST['boardNow'] : NULL;
        $gc = isset( $_REQUEST['gc'] ) ? $_REQUEST['gc'] : NULL;

        if( isset( $link ) && isset( $board ) && isset( $gc ) )
        {
            try
            {
                $gc = explode( '|', $gc );
                if( isset( $_SESSION['DeviceList'][0] ) )
                {
                    $deviceList = $_SESSION['DeviceList'];

                    if( $gc[0] != '' && $gc[1] != '' )
                        $tmp = Populator::populateChannels( $deviceList[$board], $link, $gc[0], $gc[1] );
                    else
                        $tmp = Populator::populateChannels( $deviceList[$board], $link );

                    if( $tmp != $deviceList[$board] )
                    {
                        $deviceList[$board] = $tmp;
                        $_SESSION['DeviceList'] = $deviceList;
                        $json_response['Devices'] = $_SESSION['DeviceList'];
                    }
                    else
                        $json_response['Devices'] = array( );

                    $newData = ChartPopulator::getMiniChartDataByChannel( $_SESSION['DeviceList'][$board], $link,  $gc);
                    if(isset($_SESSION['ChannelMiniCharts']))
                    {
                        if($newData != $_SESSION['ChannelMiniCharts'])
                        {
                            $json_response['MiniCharts'] = $newData;
                            $_SESSION['ChannelMiniCharts'] = $json_response['MiniCharts'];
                        }
                        else
                            $json_response['MiniCharts'] = array();
                    }
                    else
                    {
                        $json_response['MiniCharts'] = $newData;
                        $_SESSION['ChannelMiniCharts'] = $json_response['MiniCharts'];
                    }

                    $json_response['Message']['error'] = MonitorService::checkMediaServerMessages( );
                    $json_response['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                    return JSONencode( $json_response );
                }
                else
                {
                    $CountDevices = 0;
                    $CountDevices = Populator::getDeviceCount( );
                    for( $i = 0; $i < $CountDevices; $i++ )
                    {
                        $device = array( 'serial' => '', 'model' => '', 'board' => $i, 'links' => array( ) );
                        $device = Populator::prePopulateChannels( $device );
                        $deviceList[$i] = $device;
                    }
                    $_SESSION['DeviceList'] = $deviceList;
                    $json_response['Devices'] = $deviceList;
                    $json_response['MiniCharts'] = ChartPopulator::getMiniChartDataByChannel( $deviceList, $link, $gc );
                    $json_response['Message']['error'] = MonitorService::checkMediaServerMessages( );
                    $json_response['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                    return JSONencode( $json_response );
                }
            }
            catch(Exception $e)
            {
                $ret['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                $ret['Message']['error'] = $app->translateErrMessage( Querist::$last_error );
                return JSONencode( $ret );
            }
        }
    }
